#include "ros/ros.h"
#include "std_msgs/String.h"
#include "qubo_jetson/J120IMUMsg.h"

#include "RTIMULib.h"

#include <sstream>

int main(int argc, char **argv)
{
    ros::init(argc, argv, "j120imu");
    ros::NodeHandle n;
    ros::Publisher imu_pub = n.advertise<qubo_jetson::J120IMUMsg>("j120imu", 1000);

    // This loads '.ini' the file generated by the RTIMULibDemo
    RTIMUSettings *settings = new RTIMUSettings("/home/qubo/RTIMULib.ini", "RTIMULib");
    RTIMU *imu = RTIMU::createIMU(settings);

    if ((imu == NULL) || (imu->IMUType() == RTIMU_TYPE_NULL)) {
        ROS_ERROR("No IMU found\n");
        exit(1);
    }

    //  set up IMU
    imu->IMUInit();

    //  this is a convenient place to change fusion parameters
    imu->setSlerpPower(0.02);
    imu->setGyroEnable(true);
    imu->setAccelEnable(true);
    imu->setCompassEnable(true);

    int poll_interval_ms = imu->IMUGetPollInterval();
    double poll_rate = 1000 / ((double) poll_interval_ms);
    ros::Rate loop_rate(poll_rate);

    qubo_jetson::J120IMUMsg imu_msg;

    while (ros::ok())
    {
        loop_rate.sleep();

        while (imu->IMURead())
        {
            RTIMU_DATA imuData = imu->getIMUData();

            RTVector3 pose = imuData.fusionPose; // In radians 
            RTVector3 accel = imuData.accel;

            if (!imuData.accelValid)
            {
                ROS_WARN("J120 IMU giving invalid acceleration\n");
            }

            if (!imuData.fusionPoseValid)
            {
                ROS_WARN("J120 IMU giving invalid pose\n");
            }

            // TODO: Package everything up into a message and send it
            imu_msg.roll = imuData.fusionPose.x();
            imu_msg.pitch = imuData.fusionPose.y();
            imu_msg.yaw = imuData.fusionPose.z();
            imu_msg.xaccel = imuData.accel.x(); 
            imu_msg.yaccel = imuData.accel.y(); 
            imu_msg.zaccel = imuData.accel.z(); 
            imu_msg.poseValid = imuData.fusionPoseValid;
            imu_msg.accelValid = imuData.accelValid; 

            imu_pub.publish(imu_msg);
        }
    }

    return 0;
}
